"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdentifierSeperator = exports.DataChangeKeys = exports.DataChange = exports.Entity = exports.EntityEvent = exports.EntityProperty = exports.Model = void 0;
const events_1 = require("events");
class Model {
    static get modelName() {
        var _a;
        return ((_a = this.definition) === null || _a === void 0 ? void 0 : _a.name) || this.name;
    }
}
exports.Model = Model;
var EntityProperty;
(function (EntityProperty) {
    EntityProperty["ID"] = "id";
    EntityProperty["LastUpdated"] = "lastUpdated";
})(EntityProperty = exports.EntityProperty || (exports.EntityProperty = {}));
var EntityEvent;
(function (EntityEvent) {
    EntityEvent["DataChange"] = "dataChange";
})(EntityEvent = exports.EntityEvent || (exports.EntityEvent = {}));
class Entity extends Model {
    constructor() {
        super();
        this.change = new events_1.EventEmitter();
        console.log('Created Entity: ' + typeof this);
    }
    destroy() {
        // ignore
    }
    onPropertyChange(propertyKey, value) {
        if (this.change) {
            this.change.emit(EntityEvent.DataChange, {
                [propertyKey]: value
            });
        }
    }
}
exports.Entity = Entity;
class DataChange {
}
exports.DataChange = DataChange;
var DataChangeKeys;
(function (DataChangeKeys) {
    DataChangeKeys["LivePropertyDisabled"] = "$$livePropertyDisabled";
})(DataChangeKeys = exports.DataChangeKeys || (exports.DataChangeKeys = {}));
exports.IdentifierSeperator = ':';
//# sourceMappingURL=types.js.map